#!/bin/bash -x

out_file=$(pwd)/output.txt
rm -f ${out_file}

run_cmd () {
    dir=${1}
    shift
    cmd="$@"
    echo ${cmd} >> ${out_file}
    echo ++++++++++++++++++++++++++ >> ${out_file}
    pushd ${dir}
        ${cmd}  2>&1 | tee -a ${out_file}
    popd
    echo >> ${out_file}
    git add .
    git commit --allow-empty -m "${dir}: ${cmd}"
}

git add .
git commit --allow-empty -m "Initial state"

[[ -z $GO_CMD ]] && GO_CMD=go
export GOPATH=$(pwd)/gopath
export GOCACHE=$(pwd)/gocache
chmod -R +w ${GOPATH}
rm -rf ${GOPATH} ${GOCACHE}

run_cmd sample1 ${GO_CMD} mod tidy

run_cmd sample2 ${GO_CMD} mod tidy

run_cmd sample2 ${GO_CMD} install ./...
run_cmd sample1 ${GO_CMD} install ./...
run_cmd sample1 ${GO_CMD} install ./...
run_cmd sample1 ${GO_CMD} install ./...
run_cmd sample1 ${GO_CMD} install ./...
